//电机控制端口设置
const int EN1 = 3; //控制右侧电机速度
const int EN2 = 11; //控制左侧电机速度
const int EN3 = 5; //控制左侧电机速度

const int IN1 = 4; //控制右侧电机方向
const int IN2 = 12; //控制左侧电机方向
const int IN3 = 8; //控制左侧电机方向

const int UP = 1;
const int DOWN = 2;
const int LEFT = 3;
const int RIGHT = 4;
const int CW = 5;
const int CCW = 6;
unsigned int distance = 0;
unsigned int Data_Blu = 0;
unsigned int V = 0, VS = 0;
unsigned int Speed = 0;

//控制电机转动子函数
void Motor_Control(int M1_DIR, int M1_EN, int M2_DIR, int M2_EN, int M3_DIR, int M3_EN)
{
  //////////M1////////////////////////
  if (M1_DIR == 0) //M1电机的方向
    digitalWrite(IN1, HIGH); //置高，设置方向向前
  else
    digitalWrite(IN1, LOW); //置低，设置方向向后
  if (M1_EN == 0) //M1电机的速度
    analogWrite(EN1, LOW); //置低，停止
  else
    analogWrite(EN1, M1_EN); //否则，就设置相应的数值
  ///////////M2//////////////////////
  if (M2_DIR == 0) //M2电机的方向
    digitalWrite(IN2, HIGH); //置高，方向向前
  else
    digitalWrite(IN2, LOW); //置低，方向向后
  if (M2_EN == 0) //M2电机的速度
    analogWrite(EN2, LOW); //置低，停止
  else
    analogWrite(EN2, M2_EN); //否则，就设置相应的数值
  ///////////M3//////////////////////
  if (M3_DIR == 0) //M3电机的方向
    digitalWrite(IN3, HIGH); //置高，方向向前
  else
    digitalWrite(IN3, LOW); //置低，方向向后
  if (M3_EN == 0) //M3电机的速度
    analogWrite(EN3, LOW); //置低，停止
  else
    analogWrite(EN3, M3_EN); //否则，就设置相应的数值
}

void setup()
{
  Serial.begin(115200);
  pinMode(EN1, OUTPUT);
  pinMode(EN2, OUTPUT);
  pinMode(EN3, OUTPUT);
  pinMode(IN1, OUTPUT);
  pinMode(IN2, OUTPUT);
  pinMode(IN3, OUTPUT);
}

void loop()
{

  while(!Serial.available());
  if (Serial.available())
  {
    Data_Blu = Serial.read();
    VS = Data_Blu % 16;
    V = Data_Blu / 16;
  }
  if (VS != 0)
    Speed = 120;
  else
    Speed = 0;
  switch (V)
  {
    case UP:
      Motor_Control(0, 0, 1, Speed, 1, Speed);
      break;

    case DOWN:
      Motor_Control(0, 0, 0, Speed, 0, Speed);
      break;

    case LEFT:
      Motor_Control(0, Speed, 0, Speed / 2, 1, Speed / 2);
      break;

    case RIGHT:
      Motor_Control(1, Speed, 1, Speed / 2, 0, Speed / 2);
      break;
      
    case CW:
      Motor_Control(1, Speed, 0, Speed, 1, Speed);
      break;

    case CCW:
      Motor_Control(0, Speed, 1, Speed, 0, Speed );
      break;
    default:
      Motor_Control(0, 0, 0, 0, 0, 0);
  }

  delay(1);
}
